package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   󥿥եǤ
*/
public class Interface extends Group {

    /** ᥽åɤΥå */
    private Methods methods;

    /** ̾Ÿλ */
    private boolean hasNS;

    /**
       󥿥եޤ

       @param elem interface
       @param filename XMLΥե̾
    */
    public Interface(final Element elem, final String filename) {
	super(elem, filename);

	IDManager idManager = IDManager.getInstance();
	String packageName = idManager.getIDAttribute(elem, "package");
	String name = idManager.getIDAttribute(elem, "name");
	setLocation(new Location(packageName, name));

	ChildrenFilter c = getChildrenFilter();
	hasNS = (c.getDirectChildrenByTagName("namespace").getLength() > 0);

	methods = new RegularMethods(
	    this, c.getDirectChildrenByTagName("method"));
    }

    /**
       {@inheritDoc}
    */
    @Override protected boolean isNamespaceExpanded() {
	return hasNS;
    }

    /**
       {@inheritDoc}
    */
    @Override public void printCode() {
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getType() {
	return "interface";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getTexType() {
	return "interface";
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printHtmlBodyHeader(final PrintWriter wr) {
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printHtmlUsage(final PrintWriter wr) {
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printHtml(final PrintWriter wr) {
	methods.printSummary(wr);
	methods.printDetail(wr);
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printTexUsage(final PrintWriter wr) {
    }

    /**
       {@inheritDoc}
    */
    @Override protected void printTex(final PrintWriter wr) {
	methods.printTexDetail(wr);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printStub() {
    }

    /**
       {@inheritDoc}
    */
    @Override public void importTags(final String s) {
    }

    /**
       {@inheritDoc}
    */
    @Override public void importTag(final String type, final String tag) {
    }

    /**
       {@inheritDoc}
    */
    @Override protected void importXClass(final String fqcn) {
    }

    /**
       {@inheritDoc}

       s "@" ξ prefixʳξprefixs "_" Ϣ
       ʸ
    */
    @Override protected String prependPrefix(final String prefix,
					     final String s) {
	return (s.equals("@")) ? prefix : prefix + "_" + s;
    }

    /**
       {@inheritDoc}
    */
    @Override public void addCompound(final Compound compound,
				      final String type) {
    }
}
