package com.maroontress.sanctuary;

import java.io.File;

/**
   ֤̾ΰ֤Ǥ

   ֤̾ΰ֤ϥѥå̾ȥ饹̾ɽޤ
*/
public class Location {

    /** ѥå̾ */
    private String packageName;

    /** 饹̾ */
    private String className;

    /**
       ֤̾ΰ֤ޤ

       @param packageName ѥå̾
       @param className 饹̾
    */
    public Location(final String packageName, final String className) {
	this.packageName = packageName;
        this.className = className;
    }

    /**
       ֤̾˴ޤޤ륢󥫡˥󥯤HTMLʸ
       ޤ

       @param fragment ե饰
       @param anchor 󥫡
       @return 󥫡˥󥯤HTMLʸ
    */
    public String getHTMLAnchor(final String fragment, final String anchor) {
	return "<a href=\"" + packageName + "_" + className + ".html"
	    + "#" + fragment + "\">" + anchor + "</a>";
    }

    /**
       ֤̾˴ޤޤ륢󥫡˥󥯤TeXʸ
       ޤ

       @param fragment ե饰
       @param anchor 󥫡
       @return 󥫡˥󥯤TeXʸ
    */
    public String getTexAnchor(final String fragment, final String anchor) {
	String s = packageName + "." + className + "." + fragment;
	return "\\Sanchor{:" + Tex.safeTarget(s) + ":}"
	    + "{" + anchor + "}";
    }

    /**
       ֤̾Υѥå̾ޤ

       @return ѥå̾
    */
    public String getPackageName() {
	return packageName;
    }

    /**
       ֤̾Υ饹̾ޤ

       @return 饹̾
    */
    public String getClassName() {
	return className;
    }

    /**
       ֤̾ɽץեåޤ

       @return ץեå
    */
    public String getPrefix() {
	return packageName + "_" + className;
    }

    /**
       ֤̾ɽάץեåޤ

       @return άץեå
    */
    public String getSimplePrefix() {
	return className;
    }

    /**
       ֤̾Υѥޤ

       @return ѥ
    */
    public String getPath() {
        String packagePath = packageName.replace('_', File.separatorChar);
        return packagePath + File.separatorChar + className;
    }
}
